# Table of Contents

+ [Installation](../README.md#installation)

+ [Getting-started](notebooks/getting-started.ipynb): a Jupyter notebook containing a detailed explanation on how to use `regym` to solve single agent Reinforcement Learning scenarios. It walks you through: 
  1) How to create a "task" for an agent to solve.
  2) How to generate an agent from the wide pool of implemented agents suitable to solve such task.
  3) How to train the agent for a certain number of episodes.
  4) How to do a basic analysis on the trajectories created by the agent to monitor its performance.

+ [Adding a new algorithm](adding-a-new-algorithm.md): Thorough explanation on all the steps required to add a new Reinforcement Learning algorithm to `regym`. We also explain the conventions that we have been using with the rest of implemented algorithms. We are working on simplifying this process, any sugestions are welcome.

The documentation of this framework is still in very early stages. We recommend looking at the source code documentation for more detailed explanations. Do not hesitate to [open up an issue](../../../issues) if there are parts of the code base for which you would like more thorough documentation or tutorials on.
